using System;

using Microsoft.Services.TfsAlert.AppCode.NotificationEvents;

namespace Microsoft.Services.TfsAlert.AppCode
{
    public delegate void MessageAlertDelegate( object obj, MessageAlertEventArgs evtArgs );

    public class MessageAlertEventArgs : EventArgs
    {
        private Strings.BuildStatus _BuildStatus;
        private INotificationEvent _notificationEventMessage;

        public MessageAlertEventArgs(INotificationEvent notificationEventMessage )
        {
            this._notificationEventMessage = notificationEventMessage;
        }

        public MessageAlertEventArgs( INotificationEvent notificationEventMessage, Strings.BuildStatus buildStatus )
        {
            _BuildStatus = buildStatus;
            this._notificationEventMessage = notificationEventMessage;
        }

        public string NotificationEventMessageTitle
        {
            get { return this._notificationEventMessage.GetNotificationMessageTitle(); }
        }

        public string NotificationEventMessageBody
        {
            get { return this._notificationEventMessage.GetNotificationMessage(); }
        }

        public Strings.BuildStatus BuildStatus
        {
            get { return this._BuildStatus; }
        }
    }
}