//===============================================================================
// Microsoft Services
// Microsoft.Services.TfsAlert.Core
// TFSAlerts
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================

using System;
using System.Collections.Generic;
using System.Text;


using Microsoft.Services.TfsAlert.Core.BusinessFacades.RegistrationBF.Impl;

namespace Microsoft.Services.TfsAlert.Core.BusinessFacades.RegistrationBF
{
	internal sealed class RegistrationFactory : IRegistrationFactory
    {
        #region Private Members
        private static readonly IRegistrationManager _regManager = new RegistrationManagerImpl();
        private static readonly RegistrationFactory _factoryInstance = new RegistrationFactory();
        #endregion 


        #region Public Members
        public static IRegistrationFactory CreateInstance()
        {
            return _factoryInstance;
        }
        #endregion

        #region IRegistrationFactory Members

        public IRegistrationManager CreateRegistrationManager()
        {
            return _regManager;
        }

        #endregion
    }
}
