//===============================================================================
// Microsoft Services
// Microsoft.Services.TfsAlert.Core
// TFSAlerts
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Services.TfsAlert.Core.Model;


namespace Microsoft.Services.TfsAlert.Core.DataAccessLayer.TeamFoundationDL
{
    public interface ITeamFoundationDataFacade
    {
        /// <summary>
        /// Retrieves all TfsServers
        /// </summary>
        /// <returns></returns>
        List<TfsServer> RetrieveAllServers();

        /// <summary>
        /// Retrieves a TfsServer by name
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        TfsServer RetrieveServer(string name);

        /// <summary>
        /// Updates the collection of TfsServers
        /// </summary>
        /// <param name="servers"></param>
        /// <exception cref="SecurityException"></exception>
        /// <exception cref="XmlException"></exception>
        void Update(List<TfsServer> servers);

        /// <summary>
        /// Adds a new <see cref="TfsServer"/>.
        /// </summary>
        /// <param name="server"></param>
        /// <exception cref="SecurityException"></exception>
        /// <exception cref="XmlException"></exception>
        void Add(TfsServer server);
    }
}
