//===============================================================================
// Microsoft Services
// Microsoft.Services.TfsAlert.Core
// TFSAlerts
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
using System;
using System.Collections.Generic;
using System.Text;


using Microsoft.Services.TfsAlert.Core.DataAccessLayer.TeamFoundationDL.Impl;

namespace Microsoft.Services.TfsAlert.Core.DataAccessLayer.TeamFoundationDL
{
    public class TeamFoundationDAFactory
    {
        #region Private Attributes
        private static readonly TeamFoundationDAFactory _instance = new TeamFoundationDAFactory();
        #endregion

        #region Constructors
        private TeamFoundationDAFactory()
        {
        }
        #endregion

        /// <summary>
        /// Creates an Instance of <see cref="TeamFoundationDAFactory"/>
        /// </summary>
        /// <returns>TeamFoundationDAFactory</returns>
        public static TeamFoundationDAFactory CreateInstance()
        {
            return _instance;
        }

        /// <summary>
        /// Returns an instance of <see cref="ITeamFoundationDataFacade"/>
        /// </summary>
        /// <returns>ITeamFoundationDataFacade</returns>
        public ITeamFoundationDataFacade CreateTeamFoundationDAFacade()
        {
            return new TeamFoundationDLImpl();   

        }

    }
}
