//===============================================================================
// Microsoft Services
// Microsoft.Services.TfsAlert.Core
// TFSAlerts
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Services.TfsAlert.Core.BusinessFacades.RegistrationBF;
using Microsoft.Services.TfsAlert.Core.BusinessFacades.RegistrationBF.Impl;

using Microsoft.Services.TfsAlert.Core.BusinessFacades.TeamFoundationBF;
using Microsoft.Services.TfsAlert.Core.BusinessFacades.TeamFoundationBF.Impl;

namespace Microsoft.Services.TfsAlert.Core.BusinessFacades
{
    public sealed class BusinessFacadeFactory : IBusinessFacadeFactory
    {
        private static readonly BusinessFacadeFactory _instance = new BusinessFacadeFactory();

        #region Constructors
        private BusinessFacadeFactory()
        {
        }
        #endregion

        public static IBusinessFacadeFactory CreateInstance()
        {
            return _instance;
        }

        #region IBusinessFacadeFactory Members

        public ITeamFoundationFacade CreateTeamFoundationBF()
        {
            return new TeamFoundationImpl();
        }

        public IRegistrationFactory CreateRegistrationManager()
        {
            return RegistrationFactory.CreateInstance();
        }
        #endregion
    }
}
