//===============================================================================
// Microsoft Services
// Microsoft.Services.TfsAlert.Core
// TFSAlerts
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Services.TfsAlert.Core.Model
{
    public class TfsServer
    {
        #region Attributes
        private string _name;
        private string _uri;
        private string _userName;
        private List<TfsEvent> _events;
        #endregion

        #region Properties
        /// <summary>
        /// Ths Name of the server
        /// </summary>
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
     
        /// <summary>
        /// URI of the Server
        /// </summary>
        public string URI
        {
            get { return _uri; }
            set { _uri = value; }
        }
       
        /// <summary>
        /// UserName to connect to Server.
        /// </summary>
        public string UserName
        {
            get { return _userName; }
            set { _userName = value; }
        }

        /// <summary>
        /// Collection of Events
        /// </summary>
        public List<TfsEvent> Events
        {
            get { return _events; }
            set { _events = value; }
        }
        #endregion

        /// <summary>
        /// Standard ToString method passing back the name of the server.
        /// </summary>
        /// <returns>Name of the server</returns>
        public override string ToString()
        {
            return _name;
        }
    }
}
